<?php
/**
* Magic Zoom Module for Joomla 1.5
*
* @version 2.3.1.9
* @author Magic Toolbox
* @copyright (C) 2009 Magic Toolbox
* @license http://www.magictoolbox.com/license/
**/
	defined('_JEXEC') or die( 'Direct Access to this location is not allowed.' );

    require_once(dirname(__FILE__) . "/magiczoom.module.core.class.php");

	class modMagicZoom {
        var $params = Array();
        var $conf = Array();
        var $content = "";
        var $baseurl = "";
        var $page = "";
        var $coreClass = "";
        
        function modMagicZoom ($params) {
            $this->params = $params;

            $this->baseurl = JURI::base() . '/modules/mod_magiczoom/core';

            $coreClassName = 'MagicZoomModuleCoreClass';
            $this->coreClass = new $coreClassName;

            if(isset($_REQUEST["page"])) $this->page = trim($_REQUEST["page"]);
            
            $this->loadConf();
            
            $this->registerEvent('onAfterRender', 'modMagicZoomLoad');
        }
        
        function registerEvent($event,$handler) {
            /* can't use $mainframe->registerEvent function when System.Cache plugin activated */
            $dispatcher =& JDispatcher::getInstance();
            $obs = Array("event" => $event, "handler" => $handler);
            $dispatcher->_observers = array_merge(Array($obs), $dispatcher->_observers);
        }
        
        function loadConf() {
			
            $this->conf = & $this->coreClass->params;
            
            foreach($this->conf->getArray() as $key => $c) {
                $value = $this->params->get($key, "__default__");
                if($c["type"] == 'text' && $value == 'none') $value = "";
                if($value !== "__default__") {
                    $this->conf->set($key, $value);
                }
            }

        }
        
        function load() {
        
            $this->content = JResponse::toString();

            /* load JS and CSS */
            if(!defined('MagicZoom_HEADERS_LOADED')) {
                $pattern = '/<\s*(title)\s*([^>]*)(?:>(.*?)<\/\1>|\/>)/s';
                $this->content = preg_replace_callback($pattern, array($this,"loadJSCSSCallback"), $this->content);
                define('MagicZoom_HEADERS_LOADED', true);
            }

            $this->content = preg_replace('/(<body.*?>)/is', '$1' . $this->coreClass->addonsTemplate($this->baseurl), $this->content);
            
            $this->content = preg_replace_callback("/<a([^>]*?class=\"[^\"]*?MagicZoom[^\"]*?\"[^>]*)>(.*?)<\/a>/is", array($this,"loadIMGCallback"), $this->content);

            JResponse::setBody($this->content);
        }
        
        function loadJSCSSCallback($matches) {
            $utils = '<script type="text/javascript" src="' . $this->baseurl . '/utils.js"></script>';
            return $matches[0] . $utils . $this->coreClass->headers($this->baseurl);
        }

        function loadIMGCallback($matches) {
            
            $img = preg_replace("/^.*?href=\"(.*?)\".*$/is","$1",$matches[1]);
            if($img == $matches[1]) $img = '';
            
            $thumb = preg_replace("/^.*?src=\"(.*?)\".*$/is","$1",$matches[2]);
            if($thumb == $matches[2]) $thumb = '';
            
            $id = preg_replace("/^.*?id=\"(.*?)\".*$/is","$1",$matches[1]);
            if($id == $matches[1]) $id = '';
            if(preg_match('/MagicZoomImage/is',$id)) return $matches[0];
            
            $alt = preg_replace("/^.*?alt=\"(.*?)\".*$/is","$1",$matches[2]);
            if($alt == $matches[2]) $alt = '';
            
            $title = preg_replace("/^.*?title=\"(.*?)\".*$/is","$1",$matches[2]);
            if($title == $matches[2]) $title = '';
            
            $titleA = preg_replace("/^.*?title=\"(.*?)\".*$/is","$1",$matches[1]);
            if($titleA == $matches[1]) $titleA = '';
            
            $title = empty($alt) ? (empty($title) ? $titleA : $title) : $alt;
            
            $width = preg_replace("/^.*?width=\"(.*?)\".*$/is","$1",$matches[2]);
            if($width == $matches[2]) $width = '';
            
            $height = preg_replace("/^.*?height=\"(.*?)\".*$/is","$1",$matches[2]);
            if($height == $matches[2]) $height = '';

            $align = preg_replace("/^.*?align=\"(.*?)\".*$/is","$1",$matches[2]);
            if($align == $matches[2]) $align = '';
            
            $html =  $this->coreClass->template(compact('img', 'thumb', 'id', 'title','width','height'));
            
            if(!empty($id)) $html = preg_replace("/(<a[^>]*?id=\")MagicZoomImage/s", "$1", $html);
            
            $rel = preg_replace("/^.*?rel=\"(.*?)\".*$/is","$1",$matches[1]);
            if($rel != $matches[1]) {
                $relOrig = preg_replace("/^.*?rel=\"(.*?)\".*$/is","$1",$html);
                if($relOrig != $html) {
                    $rel = explode(';', $rel);
                    $relOrig = explode(';', $relOrig);
                    $relResult = Array();
                    foreach($rel as $r) {
                        if(empty($r)) continue;
                        $rr = explode(':', $r);
                        $relResult[$rr[0]] = $rr[1];
                    }
                    foreach($relOrig as $r) {
                        if(empty($r)) continue;
                        $rr = explode(':', $r);
                        if(!isset($relResult[$rr[0]]))$relResult[$rr[0]] = $rr[1];
                    }
                    $rel = array();
                    foreach($relResult as $k => $v) {
                        $rel[] = $k . ':' . $v;
                    }
                    $rel = implode(';', $rel) . ';';
                }
                $html = preg_replace("/^(.*?rel=\").*?(\".*)$/is","$1{$rel}$2",$html);
            }
            
            $html = preg_replace("/^(<a.*?<\/a>).*$/iUs", "$1", $html);
                        
            $message = trim($this->conf->getValue('message'));
            if(!empty($message) && $this->conf->checkValue("show_message", "Yes")) {
                $html = $html . "<br />" . $message;
            }
            
            //$html = "<div style=\"float:{$align}; margin: 0 3px 0 0;\">{$html}</div>";
            if(!empty($align)) $float = "float:" . $align;
            else $float = "";
            $html = "<b style=\"display: block; font-weight: normal; {$float}; margin: 0 3px 0 0; text-align: center;\">{$html}</b>";
            
            return $html;
        }
	}
	
    $GLOBALS["magictools"]["magiczoom"] = new modMagicZoom($params);
    
    function modMagicZoomLoad() {
        $GLOBALS["magictools"]["magiczoom"]->load();
    }
    
?>
